C The question is: how far off the parallactic angle can you be?
C how bad computes the amount of flux loss at w1 and w2 relative to 7000A
C (I'm assuming you are centering the star using a TV)
C general procedure:
C Read in a new star.  For every 15 minutes of the night, compute
C the LST, the HA, sec Z, the parallatic angle, and then ask yourself:
C how far from the parallactic angle can I be?
C
C
C Made a few fixes on Feb 28, 2004
	implicit double precision (a-h,o-z)
	
	character*68 inline
	character*80 outline
	character*10 date
	character*1 sign
	character*5 localt,localst
	character*4 obs(2)
C
*  SECONDS TO RADIANS
      PARAMETER (S2R=0.72722052166430398D-4)
*  ARC SECONDS TO RADIANS
      PARAMETER (AS2R=0.48481368110953599D-5)
C
*  SECONDS TO RADIANS
       STOR(RH,RM,RS)=S2R*(60D0*(60D0*RH+RM)+RS)
*  ARC SECONDS TO RADIANS
       ASTOR(DD,DM,DS)=AS2R*(60D0*(60D0*DD+DM)+DS)
	data obs/'KPNO','CTIO'/
	open(unit=1,file='knutjan05.dat',status='old')
1	write(6,2) 
2	format('RSG PROGRAM: 1=KPNO, 2=CTIO: ',$)
	read(5,*) id
	if(id.lt.1) stop
	if(id.gt.2) go to 1
	if(id.eq.1) phi=(31.+57.2/60.)*3.14159/180.
	if(id.eq.2) phi=(-30-09.9/60.)*3.14159/180.
522	write(6,51)
51	format('Input nominal slit width (arcsec):',$)
	read(5,*) slitwnom
	if((slitwnom.gt.5.).or.(slitwnom.lt.0.5)) go to 522
53	write(6,52)
52	format('What seeing to assume (arcsec):',$)
	read(5,*) seeing
	if((seeing.lt.0.5).or.(seeing.gt.5.)) go to 53
55	write(6,54)
54	format('What are the begining and ending wavelengths?',$)
	read(5,*) wave1,wave2
	if( (wave1.lt.3000.).or.(wave1.gt.10000.).or.
     &    (wave2.lt.3000.).or.(wave2.gt.10000.)) go to 55
	write(6,3)
3	format('Enter Date:')
	read(5,4) date
4	format(a10)
9	write(6,5) 
5	format('Enter sun set: 18:28')
	write(6,6)
6	format('               ',$)
	read(5,7) ihr,imin
7	format(i2,1x,i2)
	if((ihr.lt.17).or.(ihr.gt.22).or.(imin.lt.0).or.
     &       (imin.gt.59)) then
	write(6,8) ihr,imin
8	format('Problem:',i2,1x,i2,' Try again!')
	go to 9
	end if
	sunset=ihr+imin/60.
C20	write(6,21)
21	format('Enter evening twilight: 19:50')
Cwrite(6,22)
22	format('                        ',$)
Cread(5,7) ihr,imin
Cif((ihr.lt.17).or.(ihr.gt.22).or.(imin.lt.0).or.
C    &       (imin.gt.59)) then
Cwrite(6,8) ihr,imin
Cgo to 20
Cend if
Ctwile=ihr+imin/60.
C25	write(6,23)
C23	format('Enter morning twlight: 05:32')
Cwrite(6,24)
C24	format('                       ',$)
Cread(5,7) ihr,imin
Cif((ihr.lt.3).or.(ihr.gt.7).or.(imin.lt.0).or.
C    &       (imin.gt.59)) then
Cwrite(6,8) ihr,imin
Cgo to 25
Cend if
Ctwim=ihr+imin/60.
11	write(6,10)
10	format('Enter sun rise: 06:49')
	write(6,12)
12	format('                ',$)
	read(5,7) ihr,imin
	if((ihr.lt.3).or.(ihr.gt.7).or.(imin.lt.0).or.
     &       (imin.gt.59)) then
	write(6,8) ihr,imin
	go to 11
	end if
	sunrise=ihr+imin/60.
13	write(6,14)
14	format('Enter LST midnight: 10:35')
	write(6,15)
15	format('                    ',$)
	read(5,7) ihr,imin
	if((imin.lt.0).or.
     &       (imin.gt.59)) then
	write(6,8) ihr,imin
	go to 13
	end if
	stmid=ihr+imin/60.
C OK, now plan our day!
C compute for every 15 minutes during the night:
	istart=sunset+0.333
	iend=sunrise-0.333+24.+1
	write(3,107) sunset,sunrise,stmid
107	format('For the hours from',f6.1,' to ',f6.1,' STMid=',f6.1)
C Now, grab a star
1011	read(1,102,end=99) inline
	if(inline(1:1).eq.'#') go to 1011
102	format(a68)
C Now get the coordinates:
	read(inline(9:31),105) ihr,imin,sec,sign,ideg,iamin,asec
105	format(i2,1x,i2,1x,f5.2,1x,a1,i2,1x,i2,1x,f4.1)
 	write(6,105) ihr,imin,sec,sign,ideg,iamin,asec
	if(sign.eq.'-') then
	ideg=-ideg
	iamin=-iamin
	asec=-asec
	end if
	equ=2000.0
	ra1950=stor(ihr,imin,sec)
	dec1950=astor(ideg,iamin,asec)
	call mmp(ra1950,dec1950,0d0,0d0,equ,2004.9d0,ra2004,dec2004)
C	write(6,*) ihr,imin,sec,ideg,iamin,asec,ra1950,dec1950,equ
C	write(6,*) ra2004,dec2004
C Eliminate the wrong hemisphere...
	if((id.eq.1).and.(ideg.lt.-40)) go to 1011
	if((id.eq.2).and.(ideg.gt.40)) go to 1011
C OK, we now have the radian ra2004 and dec2004
C Now start moving through the night...
	outline=''
	write(outline,1044) inline(1:68)
	write(7,1045) outline
1045	format(a80)
1044	format(a68)
C
	write(3,104) inline(1:68)
      	write(3,106) obs(id),date,seeing,slitwnom,wave1,wave2
104	format(///a68)
106	format(a4,1x,a10,1x,'DIQ=',f4.1,' Slit=',f4.1,
     &  ' Wavelengths:', 2f8.0)
C
C
C
C
C
C
C
	iflag=0
	iwhat=0
	i2=0
	do 100 i=istart,iend
	do 110 j=1,4
	time=i+(j-1)*.25
	if(time.lt.(sunset+0.33)) go to 110
	if(time.gt.(sunrise-0.33+24.)) go to 110
	if(time.gt.24) time=time-24
	ihr=time
	imin=(time-ihr)*60
	write(localt,101) ihr,imin
101	format(i2.2,':',i2.2)
C figure out LST:
	timest=stmid+time
	if(timest.gt.24.) timest=timest-24.
	ihr=timest
	imin=(timest-ihr)*60
	write(localst,101) ihr,imin
C convert the LST to radians:
	timestr=timest*3600.*0.72722052166430398E-4
	ha=timestr-ra2004
	call sla_ALTAZ(ha,dec2004,phi,
     &       az,azd,azdd,el,eld,eldd,pa,pad,padd)
	if(el.lt.0.) go to 110
	pa=pa*180.0d0/3.14159d0
C OK, great!  Now let's make the pa be between 0 and 180...
	if(pa.lt.0.) pa=pa+180.
	if(pa.gt.180.) pa=pa-180.
C	write(6,*) ha*180./3.14159,pa,el*180./3.14159
C OK, that's the elevation. What's sec z?
	secz=1./dcos((3.14159d0/2-el))
	if(secz.gt.1.8) then
		if(iflag.eq.1) then
		iflag=0
		if(i2.eq.0) then
		i2=1
		write(outline(69:78),122) start,end
	write(7,1045) outline
122	format(f4.1,'-',f4.1,1x)
123	format(f4.1,'-',f4.1)
		else
		write(outline(69:77),123) start,end
	write(7,1045) outline
		end if
		end if
		go to 110
		end if
		if(iflag.eq.0) then
		iflag=1
		iwhat=1
		start=time
		end if
		end=time
	error=doit (secz,slitwnom,seeing,wave1,wave2)
C
	write(6,201) localt,localst,secz,pa,error
	write(3,201) localt,localst,secz,pa,error
201	format('Local time=',a5,' ST=',a5,' SecZ=',f7.2,' Par Ang=',
     &  f6.0,'+/-',f6.0)
110	continue
100	continue
	if(iflag.eq.1) then
	if(i2.eq.0) then
	write(outline(69:78),122) start,end
	write(7,1045) outline
	else
	write(outline(69:77),122) start,end
	write(7,1045) outline
	end if
	end if
	if(iwhat.eq.1) write(4,133) outline
	write(7,1045) outline
133	format(a80)
	go to 1011 
99	stop
	end
	double precision function doit(secz,slitwnom,seeing,wave1,wave2)
C What is the error on the parallactic angle?
C
	implicit double precision(a-h,o-z)
	wavelow=wave1
	wavehigh=wave2
	if(wavelow.gt.wavehigh) then
		wavelow=wave2
		wavehigh=wave1
	end if
C Refract all three wavelengths:
	xlow=refract(secz,wavelow)
	xhigh=refract(secz,wavehigh)
C These are the refraction relative to 7000A (see "refract)
C Now figure out the displacement relative to the tv image:
Cwrite(6,22) secz,wavelow,xlow,wavehigh,xhigh
22	format('Refraction for secz=',f6.2,
     &   ' Wavelow:',f7.1,f6.2,' Wavehigh:',f7.1,f6.2)
C How big a slit do we need to not lose more than 2% of the light?
C Let's start with a slit that is reasonable in width:
C a is the HALF-WIDTH of the slit:
	sigma=seeing/2.
	bigx=abs(xlow)
	if(abs(xhigh).gt.big) bigx=abs(xhigh)
	a=slitnom/2.
	if(a.lt.bigx) a=bigx
10	continue
C Now, unfortunately to do this right, we really much check at multiple
C wavelengths along the slit:
	wave=wavelow
	big=0.
	small=1.0
1	x0=refract(secz,wave)
	a1=a-x0
	a2=a+x0
C	write(6,*) a1,a2,sigma
	flux=0.5*(agauss(a1,0.,sigma)+agauss(a2,0.,sigma))
	if(flux.gt.big) big=flux
	if(flux.lt.small) small=flux
C	write(6,30) wave,x0,flux,small,big
30	format('Wave=',f7.1,' x0=',f5.2,' flux=',f6.2,' small, big=',2f6.2)
	wave=wave+50.
	if(wave.gt.wavehigh) go to 2
	go to 1
2	ratio=small/big
Cwrite(6,3) a,ratio
3	format('a, ratio=',2f8.2)
C We want this number to be greater than 0.98
	if(ratio.lt.0.98) then
	a=a+0.1
	go to 10
	end if
C We made it!
	slitneed=2*a
	if (slitneed.lt.slitwnom) then
	ang=0.
	else
	ratio=slitwnom/slitneed
	ang=dacos(ratio)*180./3.14159
	end if
	doit=90.-ang
	write(6,33) 90.-ang
33	format('Should be within',f6.2,' of the parallactic angle')
	return
	end
c function agauss.f
c
c source
c   Bevington, page 48.
c
c purpose
c   evaluate integral of gaussian probability function
c
c usage
c   result = agauss (x, averag, sigma)
c
c description of parameters
c   x      - limit for integral
c   averag - mean of distribution
c   sigma  - standard deviation of distribution
c   integration range is averag +/- z*sigma
c      where z = abs(x-averag)/sigma
c
c subroutines and function subprograms required
c   none
c
	function agauss (x,averag,sigma)
	implicit double precision (a-h,o-z)
11	z=abs(x-averag)/sigma
	agauss=0.
	if (z) 42,42,21
21	term=0.7071067812*z
22	sum=term
	y2=(z**2)/2.
	denom=1.
c
c accumulate sums of terms
c
31	denom=denom+2.
32	term=term*(y2*2./denom)
33	sum=sum+term
	if (term/sum-1.e-10) 41,41,31
41	agauss=1.128379167*sum*dexp(-y2)
42	return
	end
	double precision function refract(secz,wave)
	implicit double precision(a-h,o-z)
C THIS IS THE ONLY PLACE THAT THE TV WAVELENGTH ENTERS: ASSUMED 7000A
	cosz=1.0/secz
	alat=3.14159*30./180.
	z=dacos(cosz)
Cwrite(6,222) secz,cosz,z,z*180./3.14159
222	format('secz,cosz,z,zdeg',4f12.6)
	w=wave/10000.
	call sla_refro(z,2000.0d0,280d0,800d0,0.3d0,0.7d0,alat,
     &  0.0065D0,
     &   1D-8,ref5)
	call sla_refro(z,2000.0d0,280d0,800d0,0.3d0,w,alat,
     &  0.0065D0,
     &   1D-8,refwave)
	delta=206265.*(refwave-ref5)
Cwrite(6,*) ref5*206265.,refwave*206265.,delta
	refract=delta
	return
	end
      SUBROUTINE sla_REFRO (ZOBS, HM, TDK, PMB, RH, WL, PHI, TLR,
     :                      EPS, REF)
*+
*     - - - - - -
*      R E F R O
*     - - - - - -
*
*  Atmospheric refraction for radio and optical wavelengths
*
*  Given:
*    ZOBS    d  observed zenith distance of the source (radian)
*    HM      d  height of the observer above sea level (metre)
*    TDK     d  ambient temperature at the observer (deg K)
*    PMB     d  pressure at the observer (millibar)
*    RH      d  relative humidity at the observer (range 0-1)
*    WL      d  effective wavelength of the source (micrometre)
*    PHI     d  latitude of the observer (radian, astronomical)
*    TLR     d  temperature lapse rate in the troposphere (degK/metre)
*    EPS     d  precision required to terminate iteration (radian)
*
*  Returned:
*    REF     d  refraction: in vacuo ZD minus observed ZD (radian)
*
*  Suggested values for the TLR and EPS arguments are 0.0065D0
*  and 1D-8 respectively.  The result is usually at least two
*  orders of magnitude more precise than the supplied EPS value.
*
*  This routine computes the refraction for zenith distances up to
*  and a little beyond 90 deg using the method of Hohenkerk and
*  Sinclair (NAO Technical Notes 59 and 63).  The code is a
*  modified form of the optical refraction subroutine AREF of
*  C.Hohenkerk (HMNAO, September 1984), with extensions to support
*  radio wavelengths.  Most of the modifications to the HMNAO optical
*  algorithm are cosmetic, but the numerical integration phase has
*  been rearranged for extra clarity;  in addition the angle arguments
*  have been changed to radians, any value of ZOBS is allowed, and other
*  argument values have been limited to safe values.  The radio
*  expressions were devised by A.T.Sinclair (RGO - private
*  communication), based upon the Essen & Froome refractivity formula
*  adopted in Resolution 1 of the 13th International Geodesy Association
*  General Assembly (Bulletin Geodesique 1963 p390).
*
*  The radio refraction is chosen by specifying WL > 100 micrometres.
*
*  Before use, the value of ZOBS is expressed in the range +/- pi.
*  If this ranged ZOBS is -ve, the result REF is computed from its
*  absolute value before being made -ve to match.  In addition, if
*  it has an absolute value greater than 93 deg, a fixed REF value
*  equal to the result for ZOBS = 93 deg is returned, appropriately
*  signed.
*
*  Fixed values of the water vapour exponent, height of tropopause, and
*  height at which refraction is negligible are used.
*
*  Called:  sla_DRANGE, sla__ATMT, sla__ATMS
*
*  Original version by C.Hohenkerk, HMNAO, September 1986.
*  This Starlink version by P.T.Wallace, 30 December 1994.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ZOBS,HM,TDK,PMB,RH,WL,PHI,TLR,EPS,REF

*
*  Fixed parameters
*
      DOUBLE PRECISION D93,GCR,DMD,DMW,S,DELTA,HT,HS
*  93 degrees in radians
      PARAMETER (D93=1.623156204D0)
*  Universal gas constant
      PARAMETER (GCR=8314.36D0)
*  Molecular weight of dry air
      PARAMETER (DMD=28.966D0)
*  Molecular weight of water vapour
      PARAMETER (DMW=18.016D0)
*  Mean Earth radius (metre)
      PARAMETER (S=6378120D0)
*  Exponent of temperature dependence of water vapour pressure
      PARAMETER (DELTA=18.36D0)
*  Height of tropopause (metre)
      PARAMETER (HT=11000D0)
*  Upper limit for refractive effects (metre)
      PARAMETER (HS=80000D0)

      INTEGER IS,K,N,I,J
      LOGICAL OPTIC,LOOP
      DOUBLE PRECISION ZOBS1,ZOBS2,HMOK,TDKOK,PMBOK,RHOK,WLOK,ALPHA,
     :                 TOL,WLSQ,GB,A,GAMAL,GAMMA,GAMM2,DELM2,PW0,W,
     :                 C1,C2,C3,C4,C5,C6,R0,TEMPO,DN0,DNDR0,SK0,F0,
     :                 RT,TT,DNT,DNDRT,SINE,ZT,FT,DNTS,DNDRTS,ZTS,FTS,
     :                 RS,DNS,DNDRS,ZS,FS,REFOLD,Z0,ZRANGE,FB,FF,FO,FE,
     :                 H,R,SZ,RG,DR,TG,DN,DNDR,T,F,REFP,REFT

      DOUBLE PRECISION sla_DRANGE

*  The refraction integrand
      DOUBLE PRECISION REFI
      REFI(R,DN,DNDR) = R*DNDR/(DN+R*DNDR)



*  Transform ZOBS into the normal range
      ZOBS1 = sla_DRANGE(ZOBS)
      ZOBS2 = MIN(ABS(ZOBS1),D93)

*  Keep other arguments within safe bounds
      HMOK = MIN(MAX(HM,-1D3),10D3)
      TDKOK = MIN(MAX(TDK,100D0),500D0)
      PMBOK = MIN(MAX(PMB,0D0),10000D0)
      RHOK = MIN(MAX(RH,0D0),1D0)
      WLOK = MAX(WL,0.1D0)
      ALPHA = MIN(MAX(ABS(TLR),0.001D0),0.01D0)

*  Tolerance for iteration
      TOL = MIN(ABS(EPS),0.1D0)/2D0

*  Decide whether optical or radio case - switch at 100 micron
      OPTIC = WLOK.LE.100D0

*  Set up model atmosphere parameters defined at the observer
      WLSQ = WLOK*WLOK
      GB = 9.784D0*(1D0-0.0026D0*COS(PHI+PHI)-0.00000028D0*HMOK)
      IF (OPTIC) THEN
         A = (287.604D0+(1.6288D0+0.0136D0/WLSQ)/WLSQ)
     :                                              *273.15D-6/1013.25D0
      ELSE
         A = 77.624D-6
      END IF
      GAMAL = (GB*DMD)/GCR
      GAMMA = GAMAL/ALPHA
      GAMM2 = GAMMA-2D0
      DELM2 = DELTA-2D0
      PW0 = RHOK*(TDKOK/247.1D0)**DELTA
      W = PW0*(1D0-DMW/DMD)*GAMMA/(DELTA-GAMMA)
      C1 = A*(PMBOK+W)/TDKOK
      IF (OPTIC) THEN
         C2 = (A*W+11.2684D-6*PW0)/TDKOK
      ELSE
         C2 = (A*W+12.92D-6*PW0)/TDKOK
      END IF
      C3 = (GAMMA-1D0)*ALPHA*C1/TDKOK
      C4 = (DELTA-1D0)*ALPHA*C2/TDKOK
      IF (OPTIC) THEN
         C5 = 0D0
         C6 = 0D0
      ELSE
         C5 = 371897D-6*PW0/TDKOK
         C6 = C5*DELM2*ALPHA/(TDKOK*TDKOK)
      END IF

*  At the observer
      R0 = S+HMOK
      CALL sla__ATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                                               R0,TEMPO,DN0,DNDR0)
      SK0 = DN0*R0*SIN(ZOBS2)
      F0 = REFI(R0,DN0,DNDR0)

*  At the tropopause in the troposphere
      RT = S+HT
      CALL sla__ATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                                                  RT,TT,DNT,DNDRT)
      SINE = SK0/(RT*DNT)
      ZT = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FT = REFI(RT,DNT,DNDRT)

*  At the tropopause in the stratosphere
      CALL sla__ATMS(RT,TT,DNT,GAMAL,RT,DNTS,DNDRTS)
      SINE = SK0/(RT*DNTS)
      ZTS = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FTS = REFI(RT,DNTS,DNDRTS)

*  At the stratosphere limit
      RS = S+HS
      CALL sla__ATMS(RT,TT,DNT,GAMAL,RS,DNS,DNDRS)
      SINE = SK0/(RS*DNS)
      ZS = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FS = REFI(RS,DNS,DNDRS)

*
*  Integrate the refraction integral in two parts;  first in the
*  troposphere (K=1), then in the stratosphere (K=2)
*

*  Initialize previous refraction to ensure at least two iterations
      REFOLD = 1D6

*  Start off with 8 strips for the troposphere integration, and then
*  use the final troposphere value for the stratosphere integration,
*  which tends to need more strips
      IS = 8

*  Troposphere then stratosphere
      DO K = 1,2

*     Start Z, Z range, and start and end values
         IF (K.EQ.1) THEN
            Z0 = ZOBS2
            ZRANGE = ZT-Z0
            FB = F0
            FF = FT
         ELSE
            Z0 = ZTS
            ZRANGE = ZS-Z0
            FB = FTS
            FF = FS
         END IF

*     Sums of odd and even values
         FO = 0D0
         FE = 0D0

*     First time through loop we have to do every point
         N = 1

*     Start of iteration loop (terminates at specified precision)
         LOOP = .TRUE.
         DO WHILE (LOOP)

*        Strip width
            H = ZRANGE/DBLE(IS)

*        Initialize distance from Earth centre for quadrature pass
            IF (K.EQ.1) THEN
               R = R0
            ELSE
               R = RT
            END IF

*        One pass (no need to compute evens after first time)
            DO I=1,IS-1,N

*           Sine of observed zenith distance
               SZ = SIN(Z0+H*DBLE(I))

*           Find R (to nearest metre, maximum four iterations)
               IF (SZ.GT.1D-20) THEN
                  W = SK0/SZ
                  RG = R
                  DR = 1D6
                  J = 0
                  DO WHILE (ABS(DR).GT.1D0.AND.J.LT.4)
                     J=J+1
                     IF (K.EQ.1) THEN
                        CALL sla__ATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,
     :                                  C1,C2,C3,C4,C5,C6,RG,TG,DN,DNDR)
                     ELSE
                        CALL sla__ATMS(RT,TT,DNT,GAMAL,RG,DN,DNDR)
                     END IF
                     DR = (RG*DN-W)/(DN+RG*DNDR)
                     RG = RG-DR
                  END DO
                  R = RG
               END IF

*           Find refractive index and integrand at R
               IF (K.EQ.1) THEN
                  CALL sla__ATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,
     :                                    C1,C2,C3,C4,C5,C6,R,T,DN,DNDR)
               ELSE
                  CALL sla__ATMS(RT,TT,DNT,GAMAL,R,DN,DNDR)
               END IF
               F = REFI(R,DN,DNDR)

*           Accumulate odd and (first time only) even values
               IF (N.EQ.1.AND.MOD(I,2).EQ.0) THEN
                  FE = FE+F
               ELSE
                  FO = FO+F
               END IF
            END DO

*        Evaluate the integrand using Simpson's Rule
            REFP = H*(FB+4D0*FO+2D0*FE+FF)/3D0

*        Has the required precision been achieved?
            IF (ABS(REFP-REFOLD).GT.TOL) THEN

*           No: prepare for next iteration

*           Save current value for convergence test
               REFOLD = REFP

*           Double the number of strips
               IS = IS+IS

*           Sum of all current values = sum of next pass's even values
               FE = FE+FO

*           Prepare for new odd values
               FO = 0D0

*           Skip even values next time
               N = 2
            ELSE

*           Yes: save troposphere component and terminate loop
               IF (K.EQ.1) REFT = REFP
               LOOP = .FALSE.
            END IF
         END DO
      END DO

*  Result
      REF = REFT+REFP
      IF (ZOBS1.LT.0D0) REF = -REF

      END
      SUBROUTINE sla__ATMT (R0, T0, ALPHA, GAMM2, DELM2,
     :                      C1, C2, C3, C4, C5, C6, R, T, DN, DNDR)
*+
*     - - - - -
*      A T M T
*     - - - - -
*
*  Internal routine used by REFRO
*
*  Refractive index and derivative wrt height for the troposphere
*
*  Given:
*    R0      d    height of observer from centre of the Earth (metre)
*    T0      d    temperature at the observer (deg K)
*    ALPHA   d    alpha          )
*    GAMM2   d    gamma minus 2  ) see HMNAO paper
*    DELM2   d    delta minus 2  )
*    C1      d    useful term  )
*    C2      d    useful term  )
*    C3      d    useful term  ) see source
*    C4      d    useful term  ) of sla_REFRO
*    C5      d    useful term  )
*    C6      d    useful term  )
*    R       d    current distance from the centre of the Earth (metre)
*
*  Returned:
*    T       d    temperature at R (deg K)
*    DN      d    refractive index at R
*    DNDR    d    rate the refractive index is changing at R
*
*  This routine is a version of the ATMOSTRO routine (C.Hohenkerk,
*  HMNAO), with enhancements, specified by A.T.Sinclair (RGO) to
*  handle the radio case.
*
*  Note that in the optical case C5 and C6 are zero.
*
*  Original version by C.Hohenkerk, HMNAO, August 1984
*  This Starlink version by P.T.Wallace, 26 July 1993
*-

      IMPLICIT NONE

      DOUBLE PRECISION R0,T0,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                 R,T,DN,DNDR

      DOUBLE PRECISION TT0,TT0GM2,TT0DM2


      T = T0-ALPHA*(R-R0)
      TT0 = MAX(T/T0,0D0)
      TT0GM2 = TT0**GAMM2
      TT0DM2 = TT0**DELM2
      DN = 1D0+(C1*TT0GM2-(C2-C5/T)*TT0DM2)*TT0
      DNDR = -C3*TT0GM2+(C4-C6/TT0)*TT0DM2

      END
      DOUBLE PRECISION FUNCTION sla_DRANGE (ANGLE)
*+
*     - - - - - - -
*      D R A N G E
*     - - - - - - -
*
*  Normalise angle into range +/- pi  (double precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result (double precision) is ANGLE expressed in the range +/- pi.
*
*  P.T.Wallace   Starlink   6 April 1990
*-

      IMPLICIT NONE

      DOUBLE PRECISION ANGLE

      DOUBLE PRECISION DPI,D2PI
      PARAMETER (DPI=3.141592653589793238462643D0)
      PARAMETER (D2PI=6.283185307179586476925287D0)


      sla_DRANGE=MOD(ANGLE,D2PI)
      IF (ABS(sla_DRANGE).GE.DPI)
     :          sla_DRANGE=sla_DRANGE-SIGN(D2PI,ANGLE)

      END

      SUBROUTINE sla__ATMS (RT, TT, DNT, GAMAL, R, DN, DNDR)
*+
*     - - - - -
*      A T M S
*     - - - - -
*
*  Internal routine used by REFRO
*
*  Refractive index and derivative wrt height for the stratosphere
*
*  Given:
*    RT      d    height of tropopause from centre of the Earth (metre)
*    TT      d    temperature at the tropopause (deg K)
*    DNT     d    refractive index at the tropopause
*    GAMAL   d    constant of the atmospheric model = G*MD/R
*    R       d    current distance from the centre of the Earth (metre)
*
*  Returned:
*    DN      d    refractive index at R
*    DNDR    d    rate the refractive index is changing at R
*
*  This routine is a version of the ATMOSSTR routine (C.Hohenkerk,
*  HMNAO), with trivial modifications.
*
*  Original version by C.Hohenkerk, HMNAO, August 1984
*  This Starlink version by P.T.Wallace, 4 July 1993
*-

      IMPLICIT NONE

      DOUBLE PRECISION RT,TT,DNT,GAMAL,R,DN,DNDR

      DOUBLE PRECISION B,W


      B = GAMAL/TT
      W = (DNT-1D0)*EXP(-B*(R-RT))
      DN = 1D0+W
      DNDR = -B*W

      END
      SUBROUTINE sla_ALTAZ (HA, DEC, PHI,
     :                      AZ, AZD, AZDD, EL, ELD, ELDD, PA, PAD, PADD)
*+
*     - - - - - -
*      A L T A Z
*     - - - - - -
*
*  Positions, velocities and accelerations for an altazimuth
*  telescope mount.
*
*  (double precision)
*
*  Given:
*     HA      d     hour angle
*     DEC     d     declination
*     PHI     d     observatory latitude
*
*  Returned:
*     AZ      d     azimuth
*     AZD     d        "    velocity
*     AZDD    d        "    acceleration
*     EL      d     elevation
*     ELD     d         "     velocity
*     ELDD    d         "     acceleration
*     PA      d     parallactic angle
*     PAD     d         "      "   velocity
*     PADD    d         "      "   acceleration
*
*  Notes:
*
*  1)  Natural units are used throughout.  HA, DEC, PHI, AZ, EL
*      and ZD are in radians.  The velocities and accelerations
*      assume constant declination and constant rate of change of
*      hour angle (as for tracking a star);  the units of AZD, ELD
*      and PAD are radians per radian of HA, while the units of AZDD,
*      ELDD and PADD are radians per radian of HA squared.  To
*      convert into practical degree- and second-based units:
*
*        angles * 360/2pi -> degrees
*        velocities * (2pi/86400)*(360/2pi) -> degree/sec
*        accelerations * ((2pi/86400)**2)*(360/2pi) -> degree/sec/sec
*
*      The velocity and acceleration factors assume the sidereal
*      tracking case.  Their respective numerical values are (exactly)
*      1/240 and (approximately) 1/3300236.9.
*
*  2)  Azimuth is returned in the range 0-2pi;  north is zero,
*      and east is +pi/2.  Elevation and parallactic angle are
*      returned in the range +/-pi/2.  Position angle is +ve
*      for a star west of the meridian and is the angle NP-star-zenith.
*
*  3)  The latitude is geodetic as opposed to geocentric.  The
*      hour angle and declination are topocentric.  Refraction and
*      deficiencies in the telescope mounting are ignored.  The
*      purpose of the routine is to give the general form of the
*      quantities.  The details of a real telescope could profoundly
*      change the results, especially close to the zenith.
*
*  4)  No range checking of arguments is carried out.
*
*  5)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude, and (for tracking a star)
*      sine and cosine of declination.
*
*  P.T.Wallace   Starlink   6 October 1994
*-
      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI,AZ,AZD,AZDD,EL,ELD,ELDD,PA,PAD,PADD

      DOUBLE PRECISION DPI,D2PI,TINY
      PARAMETER (DPI=3.1415926535897932384626433832795D0,
     :           D2PI=6.283185307179586476925286766559D0,
     :           TINY=1D-30)

      DOUBLE PRECISION SH,CH,SD,CD,SP,CP,CHCD,SDCP,X,Y,Z,RSQ,R,A,E,C,S,
     :                 Q,QD,AD,ED,EDR,ADD,EDD,QDD


*  Useful functions
      SH=SIN(HA)
      CH=COS(HA)
      SD=SIN(DEC)
      CD=COS(DEC)
      SP=SIN(PHI)
      CP=COS(PHI)
      CHCD=CH*CD
      SDCP=SD*CP
      X=-CHCD*SP+SDCP
      Y=-SH*CD
      Z=CHCD*CP+SD*SP
      RSQ=X*X+Y*Y
      R=SQRT(RSQ)

*  Azimuth and elevation
      IF (RSQ.EQ.0D0) THEN
         A=0D0
      ELSE
         A=ATAN2(Y,X)
      END IF
      IF (A.LT.0D0) A=A+D2PI
      E=ATAN2(Z,R)

*  Parallactic angle
      C=CD*SP-CH*SDCP
      S=SH*CP
      IF (C*C+S*S.GT.0) THEN
         Q=ATAN2(S,C)
      ELSE
         Q=DPI-HA
      END IF

*  Velocities and accelerations (clamped at zenith/nadir)
      IF (RSQ.LT.TINY) THEN
         RSQ=TINY
         R=SQRT(RSQ)
      END IF
      QD=-X*CP/RSQ
      AD=SP+Z*QD
      ED=CP*Y/R
      EDR=ED/R
      ADD=EDR*(Z*SP+(2D0-RSQ)*QD)
      EDD=-R*QD*AD
      QDD=EDR*(SP+2D0*Z*QD)

*  Results
      AZ=A
      AZD=AD
      AZDD=ADD
      EL=E
      ELD=ED
      ELDD=EDD
      PA=Q
      PAD=QD
      PADD=QDD

      END
	include 'astromsub.f'
